#include "des.h"

#ifdef DEBUG
#include <iostream>
#endif


ac_int<64,false> des_encrypt (
      const ac_int<64,false> &D,
      const ac_int<64,false> &K
      )
{
   ac_int<64,false> tmpD;
   ac_int<56,false> tmpK;

   tmpD = IP(D);
   tmpK = PC1(K);

#ifdef DEBUG
   std::cout << std::hex
      << "Initial " << tmpD
      << " " << tmpK
      << std::endl
      ;
#endif
   for(int i=1; i<17; i++)
   {
      ac_int<48,false> Sin;
      ac_int<32,false> Sout;
      ac_int<32,false> tmpD_R;

      ac_int<28,false> tmpK_C;
      ac_int<28,false> tmpK_D;
      
      tmpK_C = tmpK.slc<28>(28) ;
      tmpK_D = tmpK.slc<28>(0);

      // Shift Key
      if (i == 1 || i == 2 || i == 9 || i == 16) {
         tmpK_C = (tmpK_C << 1) | tmpK_C[27] ; 
         tmpK_D = (tmpK_D << 1) | tmpK_D[27] ; 
      }
      else
      {
         tmpK_C = (tmpK_C << 2) | tmpK_C.slc<2>(26)  ; 
         tmpK_D = (tmpK_D << 2) | tmpK_D.slc<2>(26)  ; 
      }
      tmpK.set_slc(28, tmpK_C) ;
      tmpK.set_slc(0,  tmpK_D) ;

#ifdef DEBUG
      std::cout << std::hex
         << "S-K    " << tmpK
         << std::endl
         ;
#endif
      // Xor with Key
      Sin = E(R(tmpD)) ^ PC2(tmpK);
      // Sboxes
      Sout = SboxLayer(Sin);

      // Xor and swap Left and Right
      tmpD_R = R(tmpD);
      R(tmpD) = L(tmpD) ^ P(Sout);
      L(tmpD) = tmpD_R;

#ifdef DEBUG
      std::cout << std::hex
         << "round " << i
         << " " << tmpD
         << " " << tmpK
         << std::endl
         ;
#endif 
   }


#ifdef DEBUG
   std::cout << std::hex
      << "final " << IP_1(tmpD)
      << std::endl
      ;
#endif

   return IP_1(tmpD);
}
