#ifndef DES_H
#define DES_H

#include "HLS/hls.h"
#ifdef __INTELFPGA_COMPILER__
#include "HLS/ac_int.h"
#else
#include "ref/ac_int.h"
#endif


// Data register slices
#define L(x) x.slc<32>(32) 
#define R(x) x.slc<32>(0)


// DES initial permutation
ac_int<64,false> IP (const ac_int<64,false> &D);

// final permutation
// It is not exactly the standard's permutation because
// we switch L & R registers even in the last round
// so the columns are switched 2 by 2
ac_int<64,false> IP_1 (const ac_int<64,false> D);

// Expension before sboxes
ac_int<48,false> E (const ac_int<32,false> &D);

// Permutation after sboxes
ac_int<32,false> P (const ac_int<32,false> &D);

// Key schedule permuted choice 1
ac_int<56,false> PC1 (const ac_int<64,false> &D);

// Key schedule permuted choice 2
ac_int<48,false> PC2 (const ac_int<56,false> &D);

// Sbox layer
ac_int<32,false> SboxLayer (const ac_int<48,false> &D );

// Main encryption function
ac_int<64,false> des_encrypt (const ac_int<64,false> &D, const ac_int<64,false> &K);

#endif
