#include "des.h"

// DES initial permutation
ac_int<64,false> IP (const ac_int<64,false> &D)
{
    ac_int<64,false> R ;
    R[63] = D[ 6]; R[62] = D[14]; R[61] = D[22]; R[60] = D[30]; R[59] = D[38]; R[58] = D[46]; R[57] = D[54]; R[56] = D[62];
    R[55] = D[ 4]; R[54] = D[12]; R[53] = D[20]; R[52] = D[28]; R[51] = D[36]; R[50] = D[44]; R[49] = D[52]; R[48] = D[60];
    R[47] = D[ 2]; R[46] = D[10]; R[45] = D[18]; R[44] = D[26]; R[43] = D[34]; R[42] = D[42]; R[41] = D[50]; R[40] = D[58];
    R[39] = D[ 0]; R[38] = D[ 8]; R[37] = D[16]; R[36] = D[24]; R[35] = D[32]; R[34] = D[40]; R[33] = D[48]; R[32] = D[56];
    R[31] = D[ 7]; R[30] = D[15]; R[29] = D[23]; R[28] = D[31]; R[27] = D[39]; R[26] = D[47]; R[25] = D[55]; R[24] = D[63];
    R[23] = D[ 5]; R[22] = D[13]; R[21] = D[21]; R[20] = D[29]; R[19] = D[37]; R[18] = D[45]; R[17] = D[53]; R[16] = D[61];
    R[15] = D[ 3]; R[14] = D[11]; R[13] = D[19]; R[12] = D[27]; R[11] = D[35]; R[10] = D[43]; R[ 9] = D[51]; R[ 8] = D[59];
    R[ 7] = D[ 1]; R[ 6] = D[ 9]; R[ 5] = D[17]; R[ 4] = D[25]; R [3] = D[33]; R[ 2] = D[41]; R[ 1] = D[49]; R[ 0] = D[57]; 
   return (R);
}

// final permutation
// It is not exactly the standard's permutation because
// we switch L & R registers even in the last round
// so the columns are switched 2 by 2
ac_int<64,false> IP_1 (const ac_int<64,false> D)
{
    ac_int<64,false> R ;
    R[63] = D[56]; R[62] = D[24]; R[61] = D[48]; R[60] = D[16]; R[59] = D[40]; R[58] = D[ 8]; R[57] = D[32]; R[56] =D[ 0];
    R[55] = D[57]; R[54] = D[25]; R[53] = D[49]; R[52] = D[17]; R[51] = D[41]; R[50] = D[ 9]; R[49] = D[33]; R[48] =D[ 1];
    R[47] = D[58]; R[46] = D[26]; R[45] = D[50]; R[44] = D[18]; R[43] = D[42]; R[42] = D[10]; R[41] = D[34]; R[40] =D[ 2];
    R[39] = D[59]; R[38] = D[27]; R[37] = D[51]; R[36] = D[19]; R[35] = D[43]; R[34] = D[11]; R[33] = D[35]; R[32] =D[ 3];
    R[31] = D[60]; R[30] = D[28]; R[29] = D[52]; R[28] = D[20]; R[27] = D[44]; R[26] = D[12]; R[25] = D[36]; R[24] =D[ 4];
    R[23] = D[61]; R[22] = D[29]; R[21] = D[53]; R[20] = D[21]; R[19] = D[45]; R[18] = D[13]; R[17] = D[37]; R[16] =D[ 5];
    R[15] = D[62]; R[14] = D[30]; R[13] = D[54]; R[12] = D[22]; R[11] = D[46]; R[10] = D[14]; R[ 9] = D[38]; R[ 8] =D[ 6];
    R[ 7] = D[63]; R[ 6] = D[31]; R[ 5] = D[55]; R[ 4] = D[23]; R[ 3] = D[47]; R[ 2] = D[15]; R[ 1] = D[39]; R[ 0] =D[ 7];
    return (R);
}

// Expension before sboxes
ac_int<48,false> E (const ac_int<32,false> &D)
{
    ac_int<48,false> R ;
    R[47] = D[ 0]; R[46] = D[31]; R[45] = D[30]; R[44] = D[29]; R[43] = D[28]; R[42] = D[27]; R[41] = D[28]; R[40] = D[27];
    R[39] = D[26]; R[38] = D[25]; R[37] = D[24]; R[36] = D[23]; R[35] = D[24]; R[34] = D[23]; R[33] = D[22]; R[32] = D[21];
    R[31] = D[20]; R[30] = D[19]; R[29] = D[20]; R[28] = D[19]; R[27] = D[18]; R[26] = D[17]; R[25] = D[16]; R[24] = D[15];
    R[23] = D[16]; R[22] = D[15]; R[21] = D[14]; R[20] = D[13]; R[19] = D[12]; R[18] = D[11]; R[17] = D[12]; R[16] = D[11];
    R[15] = D[10]; R[14] = D[ 9]; R[13] = D[ 8]; R[12] = D[ 7]; R[11] = D[ 8]; R[10] = D[ 7]; R[ 9] = D[ 6]; R[ 8] = D[ 5];
    R[ 7] = D[ 4]; R[ 6] = D[ 3]; R[ 5] = D[ 4]; R[ 4] = D[ 3]; R[ 3] = D[ 2]; R[ 2] = D[ 1]; R[ 1] = D[ 0]; R[ 0] = D[31];
    return (R);
}

// Permutation after sboxes
ac_int<32,false> P (const ac_int<32,false> &D)
{
    ac_int<32,false> R ;
    R[31] = D[16]; R[30] = D[25]; R[29] = D[12]; R[28] = D[11];
    R[27] = D[ 3]; R[26] = D[20]; R[25] = D[ 4]; R[24] = D[15];
    R[23] = D[31]; R[22] = D[17]; R[21] = D[ 9]; R[20] = D[ 6];
    R[19] = D[27]; R[18] = D[14]; R[17] = D[ 1]; R[16] = D[22];
    R[15] = D[30]; R[14] = D[24]; R[13] = D[ 8]; R[12] = D[18];
    R[11] = D[ 0]; R[10] = D[ 5]; R[ 9] = D[29]; R[ 8] = D[23];
    R[ 7] = D[13]; R[ 6] = D[19]; R[ 5] = D[ 2]; R[ 4] = D[26];
    R[ 3] = D[10]; R[ 2] = D[21]; R[ 1] = D[28]; R[ 0] = D[ 7];
    return (R);
}

// Key schedule permuted choice 1
ac_int<56,false> PC1 (const ac_int<64,false> &D)
{
    ac_int<56,false> R ;
    R[55] = D[ 7]; R[54] = D[15]; R[53] = D[23]; R[52] = D[31]; R[51] = D[39]; R[50] = D[47]; R[49] = D[55]; R[48] = D[63];
    R[47] = D[ 6]; R[46] = D[14]; R[45] = D[22]; R[44] = D[30]; R[43] = D[38]; R[42] = D[46]; R[41] = D[54]; R[40] = D[62];
    R[39] = D[ 5]; R[38] = D[13]; R[37] = D[21]; R[36] = D[29]; R[35] = D[37]; R[34] = D[45]; R[33] = D[53]; R[32] = D[61];
    R[31] = D[ 4]; R[30] = D[12]; R[29] = D[20]; R[28] = D[28]; R[27] = D[ 1]; R[26] = D[ 9]; R[25] = D[17]; R[24] = D[25];
    R[23] = D[33]; R[22] = D[41]; R[21] = D[49]; R[20] = D[57]; R[19] = D[ 2]; R[18] = D[10]; R[17] = D[18]; R[16] = D[26];
    R[15] = D[34]; R[14] = D[42]; R[13] = D[50]; R[12] = D[58]; R[11] = D[ 3]; R[10] = D[11]; R[ 9] = D[19]; R[ 8] = D[27];
    R[ 7] = D[35]; R[ 6] = D[43]; R[ 5] = D[51]; R[ 4] = D[59]; R[ 3] = D[36]; R[ 2] = D[44]; R[ 1] = D[52]; R[ 0] = D[60];
    return (R);
}


// Key schedule permuted choice 2
ac_int<48,false> PC2 (const ac_int<56,false> &D)
{
    ac_int<48,false> R ;
    R[47] = D[42]; R[46] = D[39]; R[45] = D[45]; R[44] = D[32]; R[43] = D[55]; R[42] = D[51]; R[41] = D[53]; R[40] = D[28];
    R[39] = D[41]; R[38] = D[50]; R[37] = D[35]; R[36] = D[46]; R[35] = D[33]; R[34] = D[37]; R[33] = D[44]; R[32] = D[52];
    R[31] = D[30]; R[30] = D[48]; R[29] = D[40]; R[28] = D[49]; R[27] = D[29]; R[26] = D[36]; R[25] = D[43]; R[24] = D[54];
    R[23] = D[15]; R[22] = D[ 4]; R[21] = D[25]; R[20] = D[19]; R[19] = D[ 9]; R[18] = D[ 1]; R[17] = D[26]; R[16] = D[16];
    R[15] = D[ 5]; R[14] = D[11]; R[13] = D[23]; R[12] = D[ 8]; R[11] = D[12]; R[10] = D[ 7]; R[ 9] = D[17]; R[ 8] = D[ 0];
    R[ 7] = D[22]; R[ 6] = D[ 3]; R[ 5] = D[10]; R[ 4] = D[14]; R[ 3] = D[ 6]; R[ 2] = D[20]; R[ 1] = D[27]; R[ 0] = D[24];
    return (R);
}

