#include "des.h"

/*************************  S1  *************************/
static inline ac_int<4,false> S1 (const ac_int<6,false> &D)
{
    const unsigned int S1_tab[]{
           14 , 4  , 13 , 1  , 2  , 15 , 11 , 8  ,
           3  , 10 , 6  , 12 , 5  , 9  , 0  , 7  ,
           0  , 15 , 7  , 4  , 14 , 2  , 13 , 1  ,
           10 , 6  , 12 , 11 , 9  , 5  , 3  , 8  ,
           4  , 1  , 14 , 8  , 13 , 6  , 2  , 11 ,
           15 , 12 , 9  , 7  , 3  , 10 , 5  , 0  ,
           15 , 12 , 8  , 2  , 4  , 9  , 1  , 7  ,
           5  , 11 , 3  , 14 , 10 , 0  , 6  , 13 ,
    };
    ac_int<6,false> b ;
    b[5] = D[5] ; b[4] = D[0] ; b.set_slc(0,D.slc<4>(1)) ;
    return ac_int<4>(S1_tab[b]);
}
/*************************  S2  *************************/
static inline ac_int<4,false> S2 (const ac_int<6,false> &D)
{
    const unsigned int S2_tab[]{
           15 , 1  , 8  , 14 , 6  , 11 , 3  , 4  ,
           9  , 7  , 2  , 13 , 12 , 0  , 5  , 10 ,
           3  , 13 , 4  , 7  , 15 , 2  , 8  , 14 ,
           12 , 0  , 1  , 10 , 6  , 9  , 11 , 5  ,
           0  , 14 , 7  , 11 , 10 , 4  , 13 , 1  ,
           5  , 8  , 12 , 6  , 9  , 3  , 2  , 15 ,
           13 , 8  , 10 , 1  , 3  , 15 , 4  , 2  ,
           11 , 6  , 7  , 12 , 0  , 5  , 14 , 9  ,
    };
    ac_int<6,false> b ;
    b[5] = D[5] ; b[4] = D[0] ; b.set_slc(0,D.slc<4>(1)) ;
    return ac_int<4>(S2_tab[b]);
}
/*************************  S3  *************************/
static inline ac_int<4,false> S3 (const ac_int<6,false> &D)
{
    const unsigned int S3_tab[]{
           10 , 0  , 9  , 14 , 6  , 3  , 15 , 5  ,
           1  , 13 , 12 , 7  , 11 , 4  , 2  , 8  ,
           13 , 7  , 0  , 9  , 3  , 4  , 6  , 10 ,
           2  , 8  , 5  , 14 , 12 , 11 , 15 , 1  ,
           13 , 6  , 4  , 9  , 8  , 15 , 3  , 0  ,
           11 , 1  , 2  , 12 , 5  , 10 , 14 , 7  ,
           1  , 10 , 13 , 0  , 6  , 9  , 8  , 7  ,
           4  , 15 , 14 , 3  , 11 , 5  , 2  , 12 ,
    };
    ac_int<6,false> b ;
    b[5] = D[5] ; b[4] = D[0] ; b.set_slc(0,D.slc<4>(1)) ;
    return ac_int<4>(S3_tab[b]);
}
/*************************  S4  *************************/
static inline ac_int<4,false> S4 (const ac_int<6,false> &D)
{
    const unsigned int S4_tab[]{
           7  , 13 , 14 , 3  , 0  , 6  , 9  , 10 ,
           1  , 2  , 8  , 5  , 11 , 12 , 4  , 15 ,
           13 , 8  , 11 , 5  , 6  , 15 , 0  , 3  ,
           4  , 7  , 2  , 12 , 1  , 10 , 14 , 9  ,
           10 , 6  , 9  , 0  , 12 , 11 , 7  , 13 ,
           15 , 1  , 3  , 14 , 5  , 2  , 8  , 4  ,
           3  , 15 , 0  , 6  , 10 , 1  , 13 , 8  ,
           9  , 4  , 5  , 11 , 12 , 7  , 2  , 14 ,
    };
    ac_int<6,false> b ;
    b[5] = D[5] ; b[4] = D[0] ; b.set_slc(0,D.slc<4>(1)) ;
    return ac_int<4>(S4_tab[b]);
}
/*************************  S5  *************************/
static inline ac_int<4,false> S5 (const ac_int<6,false> &D)
{
    const unsigned int S5_tab[]{
           2  , 12 , 4  , 1  , 7  , 10 , 11 , 6  ,
           8  , 5  , 3  , 15 , 13 , 0  , 14 , 9  ,
           14 , 11 , 2  , 12 , 4  , 7  , 13 , 1  ,
           5  , 0  , 15 , 10 , 3  , 9  , 8  , 6  ,
           4  , 2  , 1  , 11 , 10 , 13 , 7  , 8  ,
           15 , 9  , 12 , 5  , 6  , 3  , 0  , 14 ,
           11 , 8  , 12 , 7  , 1  , 14 , 2  , 13 ,
           6  , 15 , 0  , 9  , 10 , 4  , 5  , 3  ,
    };
    ac_int<6,false> b ;
    b[5] = D[5] ; b[4] = D[0] ; b.set_slc(0,D.slc<4>(1)) ;
    return ac_int<4>(S5_tab[b]);
}
/*************************  S6  *************************/
static inline ac_int<4,false> S6 (const ac_int<6,false> &D)
{
    const unsigned int S6_tab[]{
           12 , 1  , 10 , 15 , 9  , 2  , 6  , 8  ,
           0  , 13 , 3  , 4  , 14 , 7  , 5  , 11 ,
           10 , 15 , 4  , 2  , 7  , 12 , 9  , 5  ,
           6  , 1  , 13 , 14 , 0  , 11 , 3  , 8  ,
           9  , 14 , 15 , 5  , 2  , 8  , 12 , 3  ,
           7  , 0  , 4  , 10 , 1  , 13 , 11 , 6  ,
           4  , 3  , 2  , 12 , 9  , 5  , 15 , 10 ,
           11 , 14 , 1  , 7  , 6  , 0  , 8  , 13 ,
    };
    ac_int<6,false> b ;
    b[5] = D[5] ; b[4] = D[0] ; b.set_slc(0,D.slc<4>(1)) ;
    return ac_int<4>(S6_tab[b]);
}
/*************************  S7  *************************/
static inline ac_int<4,false> S7 (const ac_int<6,false> &D)
{
    const unsigned int S7_tab[]{
           4  , 11 , 2  , 14 , 15 , 0  , 8  , 13 ,
           3  , 12 , 9  , 7  , 5  , 10 , 6  , 1  ,
           13 , 0  , 11 , 7  , 4  , 9  , 1  , 10 ,
           14 , 3  , 5  , 12 , 2  , 15 , 8  , 6  ,
           1  , 4  , 11 , 13 , 12 , 3  , 7  , 14 ,
           10 , 15 , 6  , 8  , 0  , 5  , 9  , 2  ,
           6  , 11 , 13 , 8  , 1  , 4  , 10 , 7  ,
           9  , 5  , 0  , 15 , 14 , 2  , 3  , 12 ,
    };
    ac_int<6,false> b ;
    b[5] = D[5] ; b[4] = D[0] ; b.set_slc(0,D.slc<4>(1)) ;
    return ac_int<4>(S7_tab[b]);
}
/*************************  S8  *************************/
static inline ac_int<4,false> S8 (const ac_int<6,false> &D)
{
    const unsigned int S8_tab[]{
           13 , 2  , 8  , 4  , 6  , 15 , 11 , 1  ,
           10 , 9  , 3  , 14 , 5  , 0  , 12 , 7  ,
           1  , 15 , 13 , 8  , 10 , 3  , 7  , 4  ,
           12 , 5  , 6  , 11 , 0  , 14 , 9  , 2  ,
           7  , 11 , 4  , 1  , 9  , 12 , 14 , 2  ,
           0  , 6  , 10 , 13 , 15 , 3  , 5  , 8  ,
           2  , 1  , 14 , 7  , 4  , 10 , 8  , 13 ,
           15 , 12 , 9  , 0  , 3  , 5  , 6  , 11 ,
    };
    ac_int<6,false> b ;
    b[5] = D[5] ; b[4] = D[0] ; b.set_slc(0,D.slc<4>(1)) ;
    return ac_int<4>(S8_tab[b]);
}

ac_int<32,false> SboxLayer (const ac_int<48,false> &D )
{

    ac_int<32,false> R ;
    R.set_slc(28, S1(D.slc<6>(42)));
    R.set_slc(24, S2(D.slc<6>(36)));
    R.set_slc(20, S3(D.slc<6>(30))); 
    R.set_slc(16, S4(D.slc<6>(24)));
    R.set_slc(12, S5(D.slc<6>(18))); 
    R.set_slc( 8, S6(D.slc<6>(12)));
    R.set_slc( 4, S7(D.slc<6>( 6))); 
    R.set_slc( 0, S8(D.slc<6>( 0)));
    return (R);
}


